/************************************************************************
 *									*
 *		g\u@r^f@botvO		*
 *									*
 *				: _Ci~bNEp[^vZ	*
 *		t@C	: dp_calc.c				*
 *									*
 ************************************************************************/
#pragma	SECTION PROG=dp_calc

#include "sg_cpu.h"

static	void	message_check(void);
static	void	dp_bit(void);
static	void	dp_testptn(void);
static	void	dp_sakuteki1(void);
static	void	dp_sakuteki2(void);
static	void	dp_sakuteki3(void);
static	void	dp_sakuteki(void);
static	void	dp_reticle(void);
static	void	dp_heading_scale1(void);
static	void	dp_sensor_heading1(void);
static	void	dp_sensor_FOR(void);
static	void	dp_sensor_LOS_symbol(void);
static	void	dp_sensor_LOS_digital(void);
static	void	dp_laser_mode(void);
static	void	dp_laser_sokukyo(void);
static	void	dp_laser_status(void);
static	void	dp_FOV_gate(void);
static	void	dp_sensor_monitor(void);
static	void	dp_speed(void);
static	void	dp_altitude(void);
static	void	dp_message(void);
static	void	dp_data_fail(void);
static	void	dp_tsuibi_gate(void);
static	void	dp_time(void);
static	void	dp_missile_symbol(void);
static	void	dp_missile_LOS(void);
static	void	dp_missile_heading1(void);
static	void	dp_missile_heading2(void);
static	void	dp_missile_alxxx(void);
static	void	dp_missile_sonzai1(void);
static	void	dp_missile_hyouji(void);
static	void	dp_missile_sonzai2(void);
static	void	dp_IFF_gate(void);
static	void	dp_IFF_gate1(void);
static	void	dp_IFF_gate2(void);
static	void	dp_IFF_gate3(void);
static	void	dp_IFF_gateA(short, IFF_GATE_A *);
static	void	dp_IFF_gateB(short, IFF_GATE_B *);
static	void	dp_IFF_gateC(short, IFF_GATE_C *);
static	void	dp_answer_code(void);
static	void	dp_obst_symbol(void);
static	void	dp_obst_kyori(void);
static	void	dp_zukei(void);
static	void	dp_zukei0(short, ZUKEI0 *, ushort *, short);
static	void	dp_zukei1(short, ZUKEI1 *, ushort *, short);
static	void	dp_zukei2(short, ZUKEI2 *, ushort *, short);
static	void	dp_zukei3(short, ZUKEI3 *, ushort *, short);
static	void	dp_heading_scale2(void);
static	void	dp_sensor_heading2(void);
static	void	dp_pitch_scale(void);
static	void	dp_sensor_pitch(void);
static	void	dp_missile_pitch(void);
static	void	dp_heading_digital(void);
static	void	dp_update_rate(void);
static	void	dp_missile(void);
static	void	dp_missile_s1(short, short);
static	void	dp_missile_s2(short, short);
static	void	dp_missile_digital(short, short);

static	ushort	zukei_color_tbl[8] = {
	COLOR_BLACK, COLOR_RED, COLOR_BLUE, COLOR_YELLOW,
	COLOR_GREEN, COLOR_MAGENTA, COLOR_CYAN, COLOR_WHITE
};

/*=======================================================================
 |
 |		_Ci~bNEp[^vZ
 |
 |	void	calc_dp;
 |
 =======================================================================*/
void	calc_dp(int check_1553B_flag)
{
	/* o^`rbgNA */
	SET_WORD(pa, 0, N_PABIT);

	/* cnsh~V{ */
	SET_PABIT(PA_KDOT00);

	/* bZ[W`FbN */
	message_check();

	/* [hւꍇAfW^l\ */
	if (sg_mode != old_sg_mode) {
		digital_update_flag = 1;
		old_sg_mode = sg_mode;
	}

	dp_update_rate();	/* XV[g\ */

	/* PTTRa̍XV[gQVgȉɂȂꍇ */
	/* "DATA FAIL" ƍXV[gȊȎSẴV{ */
	if (debug_flag == 0 && check_1553B_flag) {
		if (rate_1553B < 27) {
			dp_data_fail();
			return;
		}
	}

	dp_zukei();		/* CӐ}` */

	/* [hʂɕ\V{ */
	switch (sg_mode) {
	case MODE_BIT:
		dp_bit();
		break;
	case MODE_TESTPTN:
		dp_testptn();
		break;
	case MODE_SAKUTEKI1:
		dp_sakuteki1();
		break;
	case MODE_SAKUTEKI2:
		dp_sakuteki2();
		break;
	case MODE_SAKUTEKI3:
		dp_sakuteki3();
		break;
	case MODE_MISSILE:
		dp_missile();
		break;
	}

	data_error_flag = 0;		/* f[^G[tOZbg */

	digital_update_flag = 0;	/* fW^lXVtOZbg */
}

/*=======================================================================
 |
 |		bZ[Wω`FbN
 |
 |	void	message_check()
 |
 =======================================================================*/
static	void	message_check(void)
{
	short	dno, idata;
	int	i, j;

	dno = 22;
	for (i = 0; i < 4; i++, dno++) {
		idata = input_data[dno];

		/* f[^`FbN */
		if (data_check(dno))
			idata = 0;

		/* ω`FbN */
		if (message_data[i] != idata) {
			/* ɕ\ */
			for (j = 0; j < 3; j++) {
				if (message_no[j] == i + 1)
					break;
			}
			for ( ; j < 3; j++)
				message_no[j] = message_no[j+1];

			/* f[^OłȂԏɕ\ */
			if (idata != 0) {
				message_no[2] = message_no[1];
				message_no[1] = message_no[0];
				message_no[0] = i + 1;
			}

			/* ݂̃bZ[Wf[^ۑ */
			message_data[i] = idata;
		}
	}
}

/*=======================================================================
 |
 |		ahs[h
 |
 |	void	dp_bit()
 |
 =======================================================================*/
static	void	dp_bit(void)
{
	switch (bit_status) {
	case BIT_END:		/* I */
		break;
	case BIT_START:		/* Jn */
		/*SET_PABIT(PA_T004A);*/	/* "BYTE" */
		break;
	case BIT_NORMAL:	/*  */
		SET_PABIT(PA_T004A);	/* "BYTE" */
		SET_PABIT(PA_T004B);	/* "NORMAL" */
		break;
	case BIT_DUERR:		/* c^tG[ */
		SET_PABIT(PA_T004A);	/* "BYTE" */
		SET_PABIT(PA_T004C);	/* "D/U ERROR */
		break;
	}
}

/*=======================================================================
 |
 |		eXgp^[[h
 |
 |	void	dp_testptn()
 |
 =======================================================================*/
static	void	dp_testptn(void)
{
	/* p^[ʂɂo^`rbgZbg */
	switch (input_data[347]) {
	case 1:
		SET_PABIT(PA_T000);
		break;
	case 2:
		SET_PABIT(PA_T001);
		break;
	case 3:
		SET_PABIT(PA_T002);
		break;
	default:
		data_error_flag = 1;	/* f[^G[ */
		break;
	}
}

/*=======================================================================
 |
 |		GTCg[hP@c^ovZ
 |
 |	void	dp_sakuteki1()
 |
 =======================================================================*/
static	void	dp_sakuteki1(void)
{
	dp_sakuteki();		/* GTCg[hO */

	/* @̋yэGTCgɊւV{ */
	dp_reticle();		/* eBN */
	dp_heading_scale1();	/* ʖڐ */
	dp_sensor_heading1();	/* ZT */
	dp_sensor_FOR();	/* ZTenq */
	dp_sensor_LOS_symbol();	/* ZTknriV{j */
	dp_sensor_LOS_digital();/* ZTknrifW^j */
	dp_laser_mode();	/* [U[Ǝ˃[h */
	dp_laser_sokukyo();	/* [U[ */
	dp_laser_status();	/* [U[Xe[^X */
	dp_FOV_gate();		/* enuQ[g */
	dp_sensor_monitor();	/* ZT摜 */
	dp_speed();		/* x */
	dp_altitude();		/* x */
	dp_tsuibi_gate();	/* ǔQ[g */
	dp_time();		/*  */

	/* ~TCxɊւV{ */
	if ((input_data[29] & 0xff00)) {	/* ~TCL`FbN */
		if (data_check(29) == 0 && data_check(30) == 0 &&
				data_check(31) == 0) {	/* f[^`FbN */
			dp_missile_symbol();	/* ~TCV{ */
			dp_missile_LOS();	/* ~TCknr */
			dp_missile_heading1();	/* ~TC */
			dp_missile_alxxx();	/* ~TCx */
			dp_missile_sonzai1();	/* ~TCݕP */
			dp_missile_hyouji();	/* ~TC\ */
			dp_missile_sonzai2();	/* ~TCݕQ */
		}
	}

	/* GʏɊւV{ */
	dp_IFF_gate();		/* heeQ[g */
	dp_answer_code();	/* R[h */

	/* QTmɊւV{ */
	if (input_data[44] == 1) {		/* QL`FbN */
		dp_obst_symbol();	/* QV{ */
		dp_obst_kyori();	/* Q܂ł̍ŒZ */
	}

	dp_message();		/* bZ[WGA */
}

/*=======================================================================
 |
 |		GTCg[hQ@c^ovZ
 |
 |	void	dp_sakuteki2()
 |
 =======================================================================*/
static	void	dp_sakuteki2(void)
{
	dp_sakuteki();		/* GTCg[hO */

	/* @̋yэGTCgɊւV{ */
	dp_reticle();		/* eBN */
	dp_heading_scale2();	/* ʖڐ */
	dp_sensor_heading2();	/* ZT */
	dp_pitch_scale();	/* sb`ڐ */
	dp_sensor_pitch();	/* ZTsb` */
	dp_sensor_LOS_digital();/* ZTknrifW^j */
	dp_laser_mode();	/* [U[Ǝ˃[h */
	dp_laser_sokukyo();	/* [U[ */
	dp_laser_status();	/* [U[Xe[^X */
	dp_FOV_gate();		/* enuQ[g */
	dp_sensor_monitor();	/* ZT摜 */
	dp_speed();		/* x */
	dp_altitude();		/* x */
	dp_tsuibi_gate();	/* ǔQ[g */
	dp_time();		/*  */

	/* ~TCxɊւV{ */
	if ((input_data[29] & 0xff00)) {
		if (data_check(29) == 0 && data_check(30) == 0 &&
				data_check(31) == 0) {	/* f[^`FbN */
			dp_missile_symbol();	/* ~TCV{ */
			dp_missile_heading2();	/* ~TC */
			dp_missile_pitch();	/* ~TCsb` */
			dp_missile_alxxx();	/* ~TCx */
			dp_missile_sonzai1();	/* ~TCݕP */
			dp_missile_hyouji();	/* ~TC\ */
			dp_missile_sonzai2();	/* ~TCݕQ */
		}
	}

	/* GʏɊւV{ */
	dp_IFF_gate();		/* heeQ[g */
	dp_answer_code();	/* R[h */

	/* QTmɊւV{ */
	if (input_data[44] == 1) {
		dp_obst_symbol();	/* QV{ */
		dp_obst_kyori();	/* Q܂ł̍ŒZ */
	}

	dp_message();		/* bZ[WGA */
}

/*=======================================================================
 |
 |		GTCg[hR@c^ovZ
 |
 |	void	dp_sakuteki3()
 |
 =======================================================================*/
static	void	dp_sakuteki3(void)
{
	dp_sakuteki();		/* GTCg[hO */

	/* @̋yэGTCgɊւV{ */
	dp_reticle();		/* eBN */
	dp_heading_digital();	/* @ʁifW^j */
	dp_sensor_FOR();	/* ZTenq */
	dp_sensor_LOS_symbol();	/* ZTknriV{j */
	dp_sensor_LOS_digital();/* ZTknrifW^j */
	dp_laser_mode();	/* [U[Ǝ˃[h */
	dp_laser_sokukyo();	/* [U[ */
	dp_laser_status();	/* [U[Xe[^X */
	dp_FOV_gate();		/* enuQ[g */
	dp_sensor_monitor();	/* ZT摜 */
	dp_speed();		/* x */
	dp_altitude();		/* x */
	dp_tsuibi_gate();	/* ǔQ[g */
	dp_time();		/*  */

	/* ~TCxɊւV{ */
	if ((input_data[29] & 0xff00)) {
		if (data_check(29) == 0 && data_check(30) == 0 &&
				data_check(31) == 0) {	/* f[^`FbN */
			dp_missile_symbol();	/* ~TCV{ */
			dp_missile_LOS();	/* ~TCknr */
			dp_missile_alxxx();	/* ~TCx */
			dp_missile_sonzai1();	/* ~TCݕP */
			dp_missile_hyouji();	/* ~TC\ */
			dp_missile_sonzai2();	/* ~TCݕQ */
		}
	}

	/* GʏɊւV{ */
	dp_IFF_gate();		/* heeQ[g */
	dp_answer_code();	/* R[h */

	/* QTmɊւV{ */
	if (input_data[44] == 1) {
		dp_obst_symbol();	/* QV{ */
		dp_obst_kyori();	/* Q܂ł̍ŒZ */
	}

	dp_message();		/* bZ[WGA */
}

/*=======================================================================
 |
 |		GTCg[hO
 |
 |	void	dp_sakuteki()
 |
 =======================================================================*/
static	void	dp_sakuteki(void)
{
	/* rfI\[hʂ̂enũhbg */
	switch (input_data[346]) {
	case 0:		/* PFP[h */
		dot_video = 1128;
		break;
	case 1:		/* SFR[h */
		dot_video = 853;
		break;
	case 2:		/* PFPl[h */
		dot_video = 1280;
		break;
	default:
		data_error_flag = 1;
		break;
	}

	/* wF(C001)̐ݒ */
	if (input_data[15] == 2)
		dp.C001 = COLOR_GREEN;
	else
		dp.C001 = COLOR_WHITE;
}

/*=======================================================================
 |
 |		eBNi[U[Ǝ˓_j
 |
 |	void	dp_reticle()
 |
 =======================================================================*/
static	void	dp_reticle(void)
{
	/* f[^`FbN */
	if (data_check(8) || data_check(9))
		return;

	/* eBN̈ʒu(PX01,PY01)ݒ */
	dp.PX01 = DOT_TO_DP(input_data[8]);
	dp.PY01 = DOT_TO_DP(-input_data[9]);

	/* o^`rbgݒ */
	SET_PABIT(PA_K001);
}

/*=======================================================================
 |
 |		ʖڐiGTCg[hPj
 |
 |	void	dp_heading_scale1()
 |
 =======================================================================*/
static	void	dp_heading_scale1(void)
{
	/* f[^`FbN */
	if (data_check(2))
		return;

	/* kwQO`ݒ */
	dp.LX20A  = MM_TO_DP(((ushort)input_data[2] * 9 / 2 + 4050)
							* 1024L / 1026);

	/* o^`rbgݒ */
	SET_PABIT(PA_K020A);
}

/*=======================================================================
 |
 |		ZTʁiGTCg[hPj
 |
 |	void	dp_sensor_heading1()
 |
 =======================================================================*/
static	void	dp_sensor_heading1(void)
{
	short	roll;
	long	heading;

	/* EH[jOQiԈ葕u䕔jP̏ꍇ͕\Ȃ */
	if ((input_data[27] & 0x00ff) == 1)
		return;

	/* f[^`FbN */
	if (data_check(4) || data_check(5) || data_check(6))
		return;

	/* vZpɃ[Pʂ܂Ŏo */
	roll = ROUND(input_data[4], 10);

	/* AZ*cos(Roll) + EL*sin(Roll) vZ */
	heading = ((long)input_data[5] * (long)cos(roll) +
			(long)input_data[6] * (long)sin(roll)) >> 14;

	/* o^`rbgݒ */
	if (heading > 9000)
		SET_PABIT(PA_K020D);	/* {XOKzꍇ */
	else if (heading < -9000)
		SET_PABIT(PA_K020C);	/* |XOKzꍇ */
	else {
		dp.LX20B = MM_TO_DP((heading + 9000) * 4050 / 9000);
		SET_PABIT(PA_K020B);
	}
}

/*=======================================================================
 |
 |		ZTenq
 |
 |	void	dp_sensor_FOR()
 |
 =======================================================================*/
static	void	dp_sensor_FOR(void)
{
	/* o^`rbgݒ */
	switch (sg_mode) {
	case MODE_SAKUTEKI1:
		SET_PABIT(PA_K027A);

		/* EH[jOQP̏ꍇΊpFŕ\ */
		if ((input_data[27] & 0x00ff) == 1)
			SET_PABIT(PA_K024A);
		break;
	case MODE_SAKUTEKI3:
		SET_PABIT(PA_K027B);

		/* EH[jOQP̏ꍇΊpFŕ\ */
		if ((input_data[27] & 0x00ff) == 1)
			SET_PABIT(PA_K024B);
		break;
	}

}

/*=======================================================================
 |
 |		ZTknriV{j
 |
 |	void	dp_sensor_LOS_symbol()
 |
 =======================================================================*/
static	void	dp_sensor_LOS_symbol(void)
{
	short	tmp;

	/* f[^`FbN */
	if (data_check(5) || data_check(6))
		return;

	/* kP(LY28)̐ݒ */
	tmp = input_data[6];	/* ZTknriGx[Vljo */
	if (tmp < -3000)	/* }ROKɗ} */
		tmp = -3000;
	else if (tmp > 3000)
		tmp = 3000;
	dp.LY28 = MM_TO_DP(tmp / 5 + 600);

	/* kQ(LX28)̐ݒ */
	tmp = input_data[5];	/* ZTknriAW}Xljo */
	dp.LX28 = MM_TO_DP(tmp / 10 + 1800);

	/* o^`rbgݒ */
	switch (sg_mode) {
	case MODE_SAKUTEKI1:
		SET_PABIT(PA_K028A);
		break;
	case MODE_SAKUTEKI3:
		SET_PABIT(PA_K028B);
		break;
	}
}

/*=======================================================================
 |
 |		ZTknrifW^j
 |
 |	void	dp_sensor_LOS_digital()
 |
 =======================================================================*/
static	void	dp_sensor_LOS_digital(void)
{
	short	tmp;

	/* f[^`FbN */
	if (data_check(5) || data_check(6))
		return;

	if (digital_update_flag) {
		/* AW}Xl̂c^oݒ */
		/* iqCkjZbg */
		tmp = ROUND(input_data[5], 100);	/* ȉľܓ */
		if (tmp > 0)
			dp.A122[0] = FONT8_R;
		else if (tmp < 0) {
			dp.A122[0] = FONT8_L;
			tmp = -tmp;
		} else
			dp.A122[0] = FONT8_SP;

		/* lZbg */
		tonumR(tmp, &dp.A122[1], 3, font8_tbl, FONT8_SP);

		/* Gx[Vl̂c^oݒ */
		/* i{C|jZbg */
		tmp = ROUND(input_data[6], 100);	/* ȉľܓ */
		if (tmp > 0)
			dp.A121[0] = FONT8_PLUS;
		else if (tmp < 0) {
			dp.A121[0] = FONT8_MINUS;
			tmp = -tmp;
		} else
			dp.A121[0] = FONT8_SP;

		/* lZbg */
		tonumR(tmp, &dp.A121[1], 3, font8_tbl, FONT8_SP);
	}

	/* o^`rbgݒ */
	switch (sg_mode) {
	case MODE_SAKUTEKI1:
	case MODE_SAKUTEKI3:
		SET_PABIT(PA_KD12A);
		break;
	case MODE_SAKUTEKI2:
		SET_PABIT(PA_KD12B);
		break;
	}
}

/*=======================================================================
 |
 |		[U[Ǝ˃[hyу[U[R[h
 |
 |	void	dp_laser_mode()
 |
 =======================================================================*/
static	void	dp_laser_mode(void)
{
	static	ushort	legend[4][4] = {
		{FONT8_SP, FONT8_SP, FONT8_SP, FONT8_SP},
		{FONT8_L, FONT8_R, FONT8_F, FONT8_SP},
		{FONT8_D, FONT8_E, FONT8_S, FONT8_G},
		{FONT8_I, FONT8_F, FONT8_F, FONT8_SP}
	};
	short	laser_mode;

	/* f[^`FbN */
	if (data_check(12))
		return;

	/* WFhZbg */
	laser_mode = input_data[12];
	COPY_WORD(&dp.A142[0], legend[laser_mode], 4);

	/* [U[R[hZbg */
	if (laser_mode == 2) {
		dp.A142[4] = FONT8_SP;
		tohex(input_data[11] >> 4, &dp.A142[5], 3, font8_tbl);
		dp.A142[8] = FONT8_SP;
	} else if (laser_mode == 3) {
		tohex(input_data[11], &dp.A142[4], 4, font8_tbl);
		dp.A142[8] = FONT8_SP;
	} else {
		SET_WORD(&dp.A142[4], FONT8_SP, 4);
	}

	/* FR[hݒ */
	dp.C141 = dp.C001;		/* ^ */

	/* o^`rbgݒ */
	SET_PABIT(PA_KD141);
}

/*=======================================================================
 |
 |		[U[
 |
 |	void	dp_laser_sokukyo()
 |
 =======================================================================*/
static	void	dp_laser_sokukyo(void)
{
	/* ŋߓ_ */
	if (data_check(13) == 0) {
		if (input_data[13] != 0) {
			if (digital_update_flag) {
				/* "N " Zbg */
				dp.A144[0] = FONT8_N;
				dp.A144[1] = FONT8_SP;

				/* lZbg */
				tonumR(input_data[13], &dp.A144[2], 4,
						font8_tbl, FONT8_SP);

				/* c̃GAɃXy[XZbg */
				dp.A144[6] = dp.A144[7] = dp.A144[8] =
								FONT8_SP;
			}

			/* FR[hݒ */
			dp.C143 = dp.C001;		/* ^ */

			/* o^`rbgݒ */
			SET_PABIT(PA_KD143);
		}
	}

	/* ŉ_ */
	if (data_check(14) == 0) {
		if (input_data[14] != 0) {
			if (digital_update_flag) {
				/* "F " Zbg */
				dp.A145[0] = FONT8_F;
				dp.A145[1] = FONT8_SP;

				/* lZbg */
				tonumR(input_data[14], &dp.A145[2], 4,
						font8_tbl, FONT8_SP);

				/* c̃GAɃXy[XZbg */
				dp.A145[6] = dp.A145[7] = dp.A145[8] =
								FONT8_SP;
			}

			/* FR[hݒ */
			dp.C144 = dp.C001;		/* ^ */

			/* o^`rbgݒ */
			SET_PABIT(PA_KD144);
		}
	}
}

/*=======================================================================
 |
 |		[U[Xe[^X
 |
 |	void	dp_laser_status()
 |
 =======================================================================*/
static	void	dp_laser_status(void)
{
	/* f[^`FbN */
	if (data_check(8) || data_check(9) || data_check(10) || data_check(12))
		return;

	/* [U[Xe[^X̒Sʒu(PX02,PY02)ݒ */
	dp.PX02 = DOT_TO_DP(input_data[8]);
	dp.PY02 = DOT_TO_DP(-input_data[9]);

	/* o^`rbgݒ */
	if (input_data[10] == 1) {
		/* [U[Xe[^XP̏ꍇ */
		SET_PABIT(PA_K002B);
	} else if (input_data[10] == 2) {
		/* [U[Xe[^XQ̏ꍇ */
		if (data_check(26))	/* [U[Itw߃f[^`FbN */
			return;

		if (input_data[26] == 0) {
			/* [U[Itw߂Ȍꍇ */
			SET_PABIT(PA_K002A);
		} else {
			/* [U[Itw߂P̏ꍇ */
			if (blink_flag)		/* _ł */
				SET_PABIT(PA_K002A);
		}
	}
}

/*=======================================================================
 |
 |		enuQ[g
 |
 |	void	dp_FOV_gate()
 |
 =======================================================================*/
static	void	dp_FOV_gate(void)
{
	short	size2;

	/* f[^`FbN */
	if (data_check(7))
		return;

	/* ZTenuPWDSKyтQUDSKȊȌꍇ\Ȃ */
	if (input_data[7] != 1840 && input_data[7] != 2640)
		return;

	/* ŏ̂enuQ[gTCYihbgĵP^Q߂ */
	switch (input_data[346]) {
	case 0:		/* PFP[h */
		size2 = (1128 / 4) / 2;
		break;
	case 1:		/* SFR[h */
		size2 = (853 / 4) / 2;
		break;
	case 2:		/* PFPl[h */
		size2 = (1280 / 4) / 2;
		break;
	default:
		return;
	}

	/* enuQ[g̍W̐ݒ */
	dp.PX090 = DOT_TO_DP(-size2);
	dp.PY090 = DOT_TO_DP(-size2);
	dp.PX091 = DOT_TO_DP(size2);
	dp.PY091 = DOT_TO_DP(size2);

	/* o^`rbgݒ */
	SET_PABIT(PA_K009);
}

/*=======================================================================
 |
 |		ZT摜
 |
 |	void	dp_sensor_monitor()
 |
 =======================================================================*/
static	void	dp_sensor_monitor(void)
{
	static	ushort	legend7[4][4] = {
		{FONT7_S, FONT7_M, FONT7_B, FONT7_L},
		{FONT7_T, FONT7_V, FONT7_SP, FONT7_SP},
		{FONT7_F, FONT7_L, FONT7_I, FONT7_R},
		{FONT7_F, FONT7_L, FONT7_I, FONT7_R}
	};
	static	ushort	legend8[4][4] = {
		{FONT8_S, FONT8_M, FONT8_B, FONT8_L},
		{FONT8_T, FONT8_V, FONT8_SP, FONT8_SP},
		{FONT8_F, FONT8_L, FONT8_I, FONT8_R},
		{FONT8_F, FONT8_L, FONT8_I, FONT8_R}
	};
	short	sensor_screen;

	/* f[^`FbN */
	if (data_check(15))
		return;

	sensor_screen = input_data[15];
	switch (sg_mode) {
	case MODE_SAKUTEKI1:	/* G[hP */
		/* WFhZbg */
		COPY_WORD(&dp.A111_A, legend8[sensor_screen], 4);

		/* o^`rbgݒ */
		SET_PABIT(PA_KD11A);
		break;
	case MODE_SAKUTEKI2:	/* G[hQ */
		/* WFhZbg */
		COPY_WORD(&dp.A111_B, legend7[sensor_screen], 4);

		/* o^`rbgݒ */
		SET_PABIT(PA_KD11B);
		break;
	case MODE_SAKUTEKI3:	/* G[hR */
		/* WFhZbg */
		COPY_WORD(&dp.A111_A, legend8[sensor_screen], 4);

		/* o^`rbgݒ */
		SET_PABIT(PA_KD11C);
		break;
	}
}

/*=======================================================================
 |
 |		x
 |
 |	void	dp_speed()
 |
 =======================================================================*/
static	void	dp_speed(void)
{
	/* f[^`FbN */
	if (data_check(0))
		return;

	/* |TP̏ꍇ\Ȃ */
	if (input_data[0] == -51)
		return;

	if (digital_update_flag) {
		/* lZbg */
		tonumR(ABS(input_data[0]), &dp.A151[0], 3, font8_tbl,
								FONT8_SP);

		/* }CiXZbg */
		if (input_data[0] < -9)
			dp.A151[0] = FONT8_MINUS;
		else if (input_data[0] < 0)
			dp.A151[1] = FONT8_MINUS;
	}

	/* o^`rbgݒ */
	switch (sg_mode) {
	case MODE_SAKUTEKI1:	/* G[hP */
		SET_PABIT(PA_KD15A);
		break;
	case MODE_SAKUTEKI2:	/* G[hQ */
		SET_PABIT(PA_KD15B);
		break;
	case MODE_SAKUTEKI3:	/* G[hR */
		SET_PABIT(PA_KD15C);
		break;
	}
}

/*=======================================================================
 |
 |		x
 |
 |	void	dp_altitude()
 |
 =======================================================================*/
static	void	dp_altitude(void)
{
	/* f[^`FbN */
	if (data_check(1))
		return;

	/* |POOP̏ꍇ\Ȃ */
	if (input_data[1] == -1001)
		return;

	if (digital_update_flag) {
		/* lZbg */
		tonumR(ABS(input_data[1]), &dp.A161[0], 5, font8_tbl,
								FONT8_SP);

		/* }CiXZbg */
		if (input_data[1] < -999)
			dp.A161[0] = FONT8_MINUS;
		else if (input_data[1] < -99)
			dp.A161[1] = FONT8_MINUS;
		else if (input_data[1] < -9)
			dp.A161[2] = FONT8_MINUS;
		else if (input_data[1] < 0)
			dp.A161[3] = FONT8_MINUS;
	}

	/* o^`rbgݒ */
	switch (sg_mode) {
	case MODE_SAKUTEKI1:	/* G[hP */
		SET_PABIT(PA_KD16A);
		break;
	case MODE_SAKUTEKI2:	/* G[hQ */
		SET_PABIT(PA_KD16B);
		break;
	case MODE_SAKUTEKI3:	/* G[hR */
		SET_PABIT(PA_KD16C);
		break;
	}
}

/*=======================================================================
 |
 |		bZ[WGA
 |
 |	void	dp_message()
 |
 =======================================================================*/
static	void	dp_message(void)
{
	static	ushort	*dp_message[3] = {dp.A131, dp.A132, dp.A133};
	static	ushort	*dp_color[3] = {&dp.C130, &dp.C131, &dp.C132};
	static	ushort	pa_a[3] = {PA_KD13A0, PA_KD13A1, PA_KD13A2};
	static	ushort	pa_b[3] = {PA_KD13B0, PA_KD13B1, PA_KD13B2};
	static	ushort	message1[9][9] = {
		{
			FONT7_SP, FONT7_SP, FONT7_SP, FONT7_SP, FONT7_SP,
			FONT7_SP, FONT7_SP, FONT7_SP, FONT7_SP
		},{
			FONT7_C,  FONT7_A,  FONT7_G,  FONT7_E,  FONT7__,
			FONT7_1,  FONT7_SP, FONT7_SP, FONT7_SP
		},{
			FONT7_C,  FONT7_A,  FONT7_G,  FONT7_E,  FONT7__,
			FONT7_2,  FONT7_SP, FONT7_SP, FONT7_SP
		},{
			FONT7_M,  FONT7_A,  FONT7_N,  FONT7_T,  FONT7_R,
			FONT7_K,  FONT7_SP, FONT7_SP, FONT7_SP
		},{
			FONT7_A,  FONT7_C,  FONT7_Q,  FONT7_SP, FONT7_SP,
			FONT7_SP, FONT7_SP, FONT7_SP, FONT7_SP
		},{
			FONT7_S,  FONT7_C,  FONT7_R,  FONT7_T,  FONT7_R,
			FONT7_K,  FONT7_SP, FONT7_SP, FONT7_SP
		},{
			FONT7_A,  FONT7_U,  FONT7_T,  FONT7_O,  FONT7_T,
			FONT7_R,  FONT7_K,  FONT7_SP, FONT7_SP
		},{
			FONT7_C,  FONT7_O,  FONT7_A,  FONT7_S,  FONT7_T,
			FONT7_SP, FONT7_SP, FONT7_SP, FONT7_SP
		},{
			FONT7_R,  FONT7_E,  FONT7_L,  FONT7_O,  FONT7_C,
			FONT7_K,  FONT7_O,  FONT7_N,  FONT7_SP
		}
	};
	static	ushort	message2[3][9] = {
		{
			FONT7_SP, FONT7_SP, FONT7_SP, FONT7_SP, FONT7_SP,
			FONT7_SP, FONT7_SP, FONT7_SP, FONT7_SP
		},{
			FONT7_C,  FONT7_E,  FONT7_N,  FONT7_T,  FONT7_R,
			FONT7_K,  FONT7_SP, FONT7_SP, FONT7_SP
		},{
			FONT7_C,  FONT7_O,  FONT7_R,  FONT7_T,  FONT7_R,
			FONT7_K,  FONT7_SP, FONT7_SP, FONT7_SP
		}
	};
	static	ushort	message3[3][9] = {
		{
			FONT7_SP, FONT7_SP, FONT7_SP, FONT7_SP, FONT7_SP,
			FONT7_SP, FONT7_SP, FONT7_SP, FONT7_SP
		},{
			FONT7_W,  FONT7__,  FONT7_H,  FONT7_O,  FONT7_T,
			FONT7_SP, FONT7_SP, FONT7_SP, FONT7_SP
		},{
			FONT7_B,  FONT7__,  FONT7_H,  FONT7_O,  FONT7_T,
			FONT7_SP, FONT7_SP, FONT7_SP, FONT7_SP
		}
	};
	static	ushort	message4[4][9] = {
		{
			FONT7_SP, FONT7_SP, FONT7_SP, FONT7_SP, FONT7_SP,
			FONT7_SP, FONT7_SP, FONT7_SP, FONT7_SP
		},{
			FONT7_Z,  FONT7_O,  FONT7_O,  FONT7_M,  FONT7__,
			FONT7_3,  FONT7_SP, FONT7_SP, FONT7_SP
		},{
			FONT7_Z,  FONT7_O,  FONT7_O,  FONT7_M,  FONT7__,
			FONT7_5,  FONT7_SP, FONT7_SP, FONT7_SP
		},{
			FONT7_Z,  FONT7_O,  FONT7_O,  FONT7_M,  FONT7__,
			FONT7_8,  FONT7_SP, FONT7_SP, FONT7_SP
		}
	};
	static	ushort	warning1[9] = {
		FONT7_L,  FONT7_A,  FONT7_S,  FONT7_E,  FONT7_R,
		FONT7__,  FONT7_C,  FONT7_N,  FONT7_T
	};
	static	ushort	warning3[9] = {
		FONT7_M,  FONT7_W,  FONT7_S,  FONT7__,  FONT7_F,
		FONT7_A,  FONT7_I,  FONT7_L,  FONT7_SP
	};
	static	ushort	warning4[9] = {
		FONT7_I,  FONT7_F,  FONT7_F,  FONT7__,  FONT7_F,
		FONT7_A,  FONT7_I,  FONT7_L,  FONT7_SP
	};
	static	ushort	data_fail[9] = {
		FONT7_D,  FONT7_A,  FONT7_T,  FONT7_A,  FONT7_SP,
		FONT7_F,  FONT7_A,  FONT7_I,  FONT7_L
	};
	int	n, i;
	ushort	*pa_bit;

	n = 0;
	pa_bit = (sg_mode == MODE_SAKUTEKI3) ? pa_b : pa_a;

	/* EH[jOP\ */
	if ((input_data[27] & 0xff00) == 0x0100) {
		COPY_WORD(dp_message[n], warning1, 9);	/* WFhZbg */
		*dp_color[n] = COLOR_YELLOW;	/* FR[hijZbg */
		SET_PABIT(pa_bit[n]);		/* o^`rbgZbg */
		n++;
	}

	/* EH[jOR\ */
	if ((input_data[28] & 0xff00) == 0x0100) {
		COPY_WORD(dp_message[n], warning3, 9);	/* WFhZbg */
		*dp_color[n] = COLOR_YELLOW;	/* FR[hijZbg */
		SET_PABIT(pa_bit[n]);		/* o^`rbgZbg */
		n++;
	}
		
	/* EH[jOS\ */
	if ((input_data[28] & 0x00ff) == 0x0001) {
		COPY_WORD(dp_message[n], warning4, 9);	/* WFhZbg */
		*dp_color[n] = COLOR_YELLOW;	/* FR[hijZbg */
		SET_PABIT(pa_bit[n]);		/* o^`rbgZbg */
		n++;
	}

	/* "DATA_FAIL" \ */
	if (n < 3 && data_error_flag != 0) {
		COPY_WORD(dp_message[n], data_fail, 9);	/* WFhZbg */
		*dp_color[n] = COLOR_YELLOW;	/* FR[hijZbg */
		SET_PABIT(pa_bit[n]);		/* o^`rbgZbg */
		n++;
	}

	/* bZ[W\ */
	for (i = 0; n < 3 ;i++, n++) {
		if (message_no[i] == 0)
			break;
		switch (message_no[i]) {
		case 1:
			COPY_WORD(dp_message[n], message1[message_data[0]], 9);
			break;
		case 2:
			COPY_WORD(dp_message[n], message2[message_data[1]], 9);
			break;
		case 3:
			COPY_WORD(dp_message[n], message3[message_data[2]], 9);
			break;
		case 4:
			COPY_WORD(dp_message[n], message4[message_data[3]], 9);
			break;
		}

		*dp_color[n] = dp.C001;		/* FR[hi^΁jZbg */
		SET_PABIT(pa_bit[n]);		/* o^`rbgZbg */
	}
}

/*=======================================================================
 |
 |		c`s`@e`hk\
 |
 |	void	dp_data_fail()
 |
 =======================================================================*/
static	void	dp_data_fail(void)
{
	static	ushort	data_fail[9] = {
		FONT7_D,  FONT7_A,  FONT7_T,  FONT7_A,  FONT7_SP,
		FONT7_F,  FONT7_A,  FONT7_I,  FONT7_L
	};

	COPY_WORD(dp.A131, data_fail, 9);
	dp.C130 = COLOR_YELLOW;
	SET_PABIT(sg_mode == MODE_SAKUTEKI3 ? PA_KD13B0 : PA_KD13A0);
}

/*=======================================================================
 |
 |		ǔQ[g
 |
 |	void	dp_tsuibi_gate()
 |
 =======================================================================*/
static	void	dp_tsuibi_gate(void)
{
	short	w, h, x, y;

	/* f[^`FbN */
	if (data_check(16) || data_check(17) || data_check(18) ||
				data_check(19) || data_check(20))
		return;

	/* ǔQ[g̎ނOɏꍇ͕\Ȃ */
	if (input_data[16] == 0 || input_data[19] == 0 || input_data[20] == 0)
		return;

	/* ̂P^Qɕϊ */
	w = DOT_TO_MM(input_data[19]) / 2;

	/* ̂P^Qɕϊ */
	h = DOT_TO_MM(input_data[20]) / 2;

	/* ǔQ[g̈ʒuo */
	x = DOT_TO_MM(input_data[17]) - 6345;
	y = 6345 - DOT_TO_MM(input_data[18]);

	/* ̍W(PX030,PY030)̐ݒ */
	dp.PX030 = MM_TO_DP(x - w);
	dp.PY030 = MM_TO_DP(y - h);

	/* E̍W(PX031,PY031)̐ݒ */
	dp.PX031 = MM_TO_DP(x + w);
	dp.PY031 = MM_TO_DP(y + h);

	/* kV(LX037)̐ݒ */
	if (w >= 450)			/* SDT(L2+L8)ȏH */
		dp.LX037 = MM_TO_DP(w * 2 - 900);
	else
		dp.LX037 = 0;

	/* kW(LX038)̐ݒ */
	if (w >= 450)			/* SDT(L2+L8)ȏH */
		dp.LX038 = MM_TO_DP(150);	/* PDT */
	else if (w >= 300)		/* R(L2)ȏH */
		dp.LX038 = MM_TO_DP(w - 300);
	else
		dp.LX038 = 0;

	/* kQ(LX032)̐ݒ */
	if (w >= 300)			/* R(L2)ȏH */
		dp.LX032 = MM_TO_DP(300);	/* R */
	else if (w >= 30)		/* ODRȏH */
		dp.LX032 = MM_TO_DP(w);
	else
		dp.LX032 = MM_TO_DP(30);	/* ODR */

	/* kP(LX031)̐ݒ */
	if (input_data[16] == 2 || input_data[16] == 4)
		dp.LX031 = dp.LX032;
	else
		dp.LX031 = 0;

	/* kU(LY036)̐ݒ */
	if (h >= 450)			/* SDT(L3+L5)ȏH */
		dp.LY036 = MM_TO_DP(h * 2 - 900);
	else
		dp.LY036 = 0;

	/* kT(LY035)̐ݒ */
	if (h >= 450)			/* SDT(L3+L5)ȏH */
		dp.LY035 = MM_TO_DP(150);	/* PDT */
	else if (h >= 300)		/* R(L3)ȏH */
		dp.LY035 = MM_TO_DP(h - 300);
	else
		dp.LY035 = 0;

	/* kR(LY033)̐ݒ */
	if (h >= 300)			/* R(L3)ȏH */
		dp.LY033 = MM_TO_DP(300);	/* R */
	else if (h >= 30)		/* ODRȏH */
		dp.LY033 = MM_TO_DP(h);
	else
		dp.LY033 = MM_TO_DP(30);	/* ODR */

	/* kS(LY034)̐ݒ */
	if (input_data[16] == 2 || input_data[16] == 3)
		dp.LY034 = dp.LY033;
	else
		dp.LY034 = 0;

	/* o^`rbgݒ */
	SET_PABIT(PA_K003);
}

/*=======================================================================
 |
 |		
 |
 |	void	dp_time()
 |
 =======================================================================*/
static	void	dp_time(void)
{
	/* f[^`FbN */
	if (data_check(350) || data_check(351) || data_check(352))
		return;

	/* b̂ꂩ|P̏ꍇ\Ȃ */
	if (input_data[350] == -1 || input_data[351] == -1 ||
						input_data[352] == -1)
		return;

	/* ~TCꍇ͕\Ȃ */
	if ((input_data[29] & 0xff00))
		return;

	/* (A1810,1811)̐ݒ */
	dp.A181[0] = font8_tbl[input_data[350] / 10];
	dp.A181[1] = font8_tbl[input_data[350] % 10];

	/* (A1812,1813)̐ݒ */
	dp.A181[2] = font8_tbl[input_data[351] / 10];
	dp.A181[3] = font8_tbl[input_data[351] % 10];

	/* b(A1814,1815)̐ݒ */
	dp.A181[4] = font8_tbl[input_data[352] / 10];
	dp.A181[5] = font8_tbl[input_data[352] % 10];

	/* o^`rbgݒ */
	SET_PABIT(PA_KD18);
}

/*=======================================================================
 |
 |		~TCV{
 |
 |	void	dp_missile_symbol()
 |
 =======================================================================*/
static	void	dp_missile_symbol(void)
{
	long	x, y;

	/* f[^`FbN */
	if (data_check(7) || data_check(357) || data_check(358))
		return;

	/* ZTenuO͕̎\Ȃ */
	if (input_data[7] == 0)
		return;

	/* ~TĈwCxWvZ */
	x = (long)dot_video * input_data[30] / input_data[7] + input_data[357];
	y = (long)dot_video * input_data[31] / input_data[7] - input_data[358];

	/* ʓɂȂꍇ\Ȃ */
	if (x > 423 || x < -423 || y > 423 || y < -423)
		return;

	/* ~TCʒuiowOTCoxOTj̐ݒ */
	dp.PX05 = DOT_TO_DP(x);
	dp.PY05 = DOT_TO_DP(y);

	/* o^`rbgݒ */
	SET_PABIT(PA_K005);
}

/*=======================================================================
 |
 |		~TCknr
 |
 |	void	dp_missile_LOS()
 |
 =======================================================================*/
static	void	dp_missile_LOS(void)
{
	long	tmp;

	/* f[^`FbN */
	if (data_check(5) || data_check(6))
		return;

	/* Gx[Vl}ROKɗ} */
	tmp = input_data[6] + input_data[31];
	if (tmp > 3000)
		tmp = 3000;
	else if (tmp < -3000)
		tmp = -3000;

	/* kP(LY23)̐ݒ */
	dp.LY23 = MM_TO_DP(tmp / 5 + 600);

	/* AW}Xl}PWOKɗ} */
	tmp = input_data[5] + input_data[30];
	if (tmp > 18000)
		tmp -= 36000;
	else if (tmp < -18000)
		tmp += 36000;

	/* kQ(LX23)̐ݒ */
	dp.LX23 = MM_TO_DP(tmp / 10 + 1800);

	/* o^`rbgݒ */
	switch (sg_mode) {
	case MODE_SAKUTEKI1:
		SET_PABIT(PA_K023A);
		break;
	case MODE_SAKUTEKI3:
		SET_PABIT(PA_K023B);
		break;
	}
}

/*=======================================================================
 |
 |		~TCʁiGTCg[hPj
 |
 |	void	dp_missile_heading1()
 |
 =======================================================================*/
static	void	dp_missile_heading1(void)
{
	long	mwaz, mwel, heading;
	short	roll;

	/* f[^`FbN */
	if (data_check(4) || data_check(5) || data_check(6))
		return;

	/* lvAŽvZ */
	mwaz = (long)input_data[30] + (long)input_data[5];
	if (mwaz > 18000)
		mwaz -= 36000;
	else if (mwaz < -18000)
		mwaz += 36000;

	/* lvEĽvZ */
	mwel = (long)input_data[31] + (long)input_data[6];
	if (mwel > 9000)
		mwel = 18000 - mwel;
	else if (mwel < -9000)
		mwel = -18000 - mwel;

	/* vZpɃ[Pʂ܂Ŏo */
	roll = ROUND(input_data[4], 10);

	/* lvAZ*cos(Roll) + lvEL*sin(Roll) vZ */
	heading = (mwaz * cos(roll) + mwel * sin(roll)) >> 14;

	/* o^`rbgݒ */
	if (heading > 9000)
		SET_PABIT(PA_K025B);	/* {XOKzꍇ */
	else if (heading < -9000)
		SET_PABIT(PA_K025C);	/* |XOKzꍇ */
	else {
		dp.LX25A = MM_TO_DP((heading + 9000) * 4050L / 9000);
		SET_PABIT(PA_K025A);
	}
}

/*=======================================================================
 |
 |		~TCʁiGTCg[hQj
 |
 |	void	dp_missile_heading2()
 |
 =======================================================================*/
static	void	dp_missile_heading2(void)
{
	long	mwaz, mwel, heading;
	short	roll;

	/* f[^`FbN */
	if (data_check(4) || data_check(5) || data_check(6))
		return;

	/* lvAŽvZ */
	mwaz = (long)input_data[30] + (long)input_data[5];
	if (mwaz > 18000)
		mwaz -= 36000;
	else if (mwaz < -18000)
		mwaz += 36000;

	/* lvEĽvZ */
	mwel = (long)input_data[31] + (long)input_data[6];
	if (mwel > 9000)
		mwel = 18000 - mwel;
	else if (mwel < -9000)
		mwel = -18000 - mwel;

	/* vZpɃ[Pʂ܂Ŏo */
	roll = ROUND(input_data[4], 10);

	/* lvAZ*cos(Roll) + lvEL*sin(Roll) vZ */
	heading = (mwaz * cos(roll) + mwel * sin(roll)) >> 14;

	if (heading > 18000)
		heading -= 36000;	/* {PWOKzꍇ */
	else if (heading < -18000)
		heading += 36000;	/* |PWOKzꍇ */

	/* LX25D ̐ݒ */
	dp.LX25D = MM_TO_DP((heading + 18000) * 2160 / 9000);

	/* o^`rbgݒ */
	SET_PABIT(PA_K025D);
}

/*=======================================================================
 |
 |		~TCx
 |
 |	void	dp_missile_alxxx(void)
 |
 =======================================================================*/
static	void	dp_missile_alxxx(void)
{
	static	ushort	legend[2][7] = {
		{FONT7_M, FONT7_I, FONT7_S, FONT7_S,
		 FONT7_I, FONT7_L, FONT7_E},
		{FONT7_L, FONT7_O, FONT7_S, FONT7_T,
		 FONT7_SP, FONT7_SP, FONT7_SP}
	};
	long	mwaz, mwel;
	short	tmp;

	/* f[^`FbN */
	if (data_check(5) || data_check(6))
		return;

	/* WFhZbg */
	COPY_WORD(&dp.A103[0], legend[input_data[29] & 0x00ff], 7);

	if (digital_update_flag) {
		/* lvAŽvZ */
		mwaz = (long)input_data[30] + (long)input_data[5];
		if (mwaz > 18000)
			mwaz -= 36000;
		else if (mwaz < -18000)
			mwaz += 36000;

		/* lvEĽvZ */
		mwel = (long)input_data[31] + (long)input_data[6];
		if (mwel > 9000)
			mwel = 18000 - mwel;
		else if (mwel < -9000)
			mwel = -18000 - mwel;

		/* Gx[Vlݒ */
		tmp = ROUND(mwel, 100);	/* ȉľܓ */
		if (tmp > 0)
			dp.A101[0] = FONT8_PLUS;
		else if (tmp < 0) {
			dp.A101[0] = FONT8_MINUS;
			tmp = -tmp;
		} else
			dp.A101[0] = FONT8_SP;
		tonumR(tmp, &dp.A101[1], 3, font8_tbl, FONT8_SP);

		/* AW}Xlݒ */
		tmp = ROUND(mwaz, 100);	/* ȉľܓ */
		if (tmp > 0)
			dp.A102[0] = FONT8_R;
		else if (tmp < 0) {
			dp.A102[0] = FONT8_L;
			tmp = -tmp;
		} else
			dp.A102[0] = FONT8_SP;
		tonumR(tmp, &dp.A102[1], 3, font8_tbl, FONT8_SP);
	}

	/* o^`rbgݒ */
	SET_PABIT(PA_KD10);
}

/*=======================================================================
 |
 |		~TCݕP
 |
 |	void	dp_missile_sonzai1()
 |
 =======================================================================*/
static	void	dp_missile_sonzai1(void)
{
	long	x, y;

	/* ԍQX̏ʂWQ͕̎\Ȃ */
	if ((input_data[29] & 0xff00) == 0x200)
		return;

	/* }XOK͈̔͂ɂȂꍇ͕\Ȃ */
	if (input_data[30] > 9000 || input_data[30] < -9000)
		return;

	/* f[^`FbN */
	if (data_check(7) || data_check(8) || data_check(9) ||
					data_check(357) || data_check(358))
		return;

	/* ZTenuO͕̎\Ȃ */
	if (input_data[7] == 0)
		return;

	/* ~TCV{ƏdȂꍇ͕\Ȃ */
	x = (long)dot_video * input_data[30] / input_data[7] - input_data[8] +
						input_data[357];
	y = (long)dot_video * input_data[31] / input_data[7] + input_data[9] -
						input_data[358];
	if (DOT_TO_MM(sqrt(x * x + y * y)) <= 1800)
		return;

	/* px(R06)̐ݒ */
	dp.R06 = atan((short)y, (short)x);

	/* o^`rbgݒ */
	SET_PABIT(PA_K006);
}

/*=======================================================================
 |
 |		~TC\
 |
 |	void	dp_missile_hyouji()
 |
 =======================================================================*/
static	void	dp_missile_hyouji(void)
{
	long	x, y;
	short	l;

	/* ԍQX̏ʂWP͕̎\Ȃ */
	if ((input_data[29] & 0xff00) == 0x100)
		return;

	/* f[^`FbN */
	if (data_check(7) || data_check(8) || data_check(9) ||
					data_check(357) || data_check(358))
		return;

	/* ZTenuO͕̎\Ȃ */
	if (input_data[7] == 0)
		return;

	/* ~TCʒûwCxWvZ */
	x = (long)dot_video * input_data[30] / input_data[7] + input_data[357];
	y = (long)dot_video * input_data[31] / input_data[7] - input_data[358];

	/* ʓɂȂꍇ\Ȃ */
	if (x > 423 || x < -423 || y > 423 || y < -423)
		return;

	/* eBN̑Έʒuɕϊ */
	x -= input_data[8];
	y += input_data[9];

	/* vZ */
	l = DOT_TO_MM(sqrt(x * x + y * y)) - 300;

	/* Oȉ̏ꍇ͕\Ȃ */
	if (l < 0)
		return;

	/* ̒(LX08)̐ݒ */
	dp.LX08 = MM_TO_DP(l);

	/* px(R08)̐ݒ */
	dp.R08 = atan((short)y, (short)x);

	/* o^`rbgݒ */
	SET_PABIT(PA_K008);
}

/*=======================================================================
 |
 |		~TCݕQ
 |
 |	void	dp_missile_sonzai2()
 |
 =======================================================================*/
static	void	dp_missile_sonzai2(void)
{
	register long	x, y, rx, ry, tx, ty, len;

	/* ԍQX̏ʂWP͕̎\Ȃ */
	if ((input_data[29] & 0xff00) == 0x100)
		return;

	/* f[^`FbN */
	if (data_check(7) || data_check(8) || data_check(9) ||
					data_check(357) || data_check(358))
		return;

	/* ZTenuO͕̎\Ȃ */
	if (input_data[7] == 0)
		return;

	/* }XOK͈̔͂ɂȂꍇ͕\Ȃ */
	if (input_data[30] > 9000 || input_data[30] < -9000)
		return;

	/* ~TCʒûwCxWvZ */
	x = (long)dot_video * input_data[30] / input_data[7] + input_data[357];
	y = (long)dot_video * input_data[31] / input_data[7] - input_data[358];

	/* ʓɂꍇ\Ȃ */
	if (x <= 423 && x >= -423 && y <= 423 && y >= -423)
		return;

	/* eBN̑Έʒuɕϊ */
	rx = x - input_data[8];
	ry = y + input_data[9];

	/* px(R07)̐ݒ */
	dp.R07 = atan((short)ry, (short)rx);

	/* wCẍʒu̐Βl߂ */
	x = ABS(x);
	y = ABS(y);
	rx = ABS(rx);
	ry = ABS(ry);

	/* w̒ʓiSOOhbgȓjɎ߂ */
	if (x > 400) {
		tx = rx - (x - 400);
		ty = ry * tx / rx;
		y -= ry - ty;
		rx = tx;
		ry = ty;
	}

	/* x̒ʓiRQOhbgȓjɎ߂ */
	if (y > 320) {
		tx = ry - (y - 320);
		rx = rx * tx / ry;
		ry = tx;
	}

	/* ߂ */
	len = DOT_TO_MM(sqrt(rx * rx + ry * ry));

	/* SDOTi̒jZꍇ͕\Ȃ */
	if (len < 405)
		return;

	/* (LX07)̐ݒ */
	dp.LX07 = MM_TO_DP(len - 405);

	/* o^`rbgݒ */
	SET_PABIT(PA_K007);
}

/*=======================================================================
 |
 |		heeQ[g
 |
 |	void	dp_IFF_gate()
 |
 =======================================================================*/
static	void	dp_IFF_gate(void)
{
	dp_IFF_gate1();
	dp_IFF_gate2();
	dp_IFF_gate3();
}

/*=======================================================================
 |
 |		heeQ[gP
 |
 |	void	dp_IFF_gate1()
 |
 =======================================================================*/
static	void	dp_IFF_gate1(void)
{
	/* f[^`FbN */
	if (data_check(32) || data_check(33) ||
				data_check(34) || data_check(35))
		return;

	/* TCYȌꍇ\Ȃ */
	if (input_data[35] == 0)
		return;

	switch (input_data[34]) {
	case 0:
		/* heeQ[g@c^ovZ */
		dp_IFF_gateA(32, &dp.IFF_gate_a[0]);

		/* o^`rbgݒ */
		SET_PABIT(PA_K004A0);
		break;
	case 1:
		/* heeQ[g@c^ovZ */
		dp_IFF_gateB(32, &dp.IFF_gate_b[0]);

		/* o^`rbgݒ */
		SET_PABIT(PA_K004B0);
		break;
	case 2:
		/* heeQ[g@c^ovZ */
		dp_IFF_gateC(32, &dp.IFF_gate_c[0]);

		/* o^`rbgݒ */
		SET_PABIT(PA_K004C0);
		break;
	}
}

/*=======================================================================
 |
 |		heeQ[gQ
 |
 |	void	dp_IFF_gate2()
 |
 =======================================================================*/
static	void	dp_IFF_gate2(void)
{
	/* f[^`FbN */
	if (data_check(36) || data_check(37) ||
				data_check(38) || data_check(39))
		return;

	/* TCYȌꍇ\Ȃ */
	if (input_data[39] == 0)
		return;

	switch (input_data[38]) {
	case 0:
		/* heeQ[g@c^ovZ */
		dp_IFF_gateA(36, &dp.IFF_gate_a[1]);

		/* o^`rbgݒ */
		SET_PABIT(PA_K004A1);
		break;
	case 1:
		/* heeQ[g@c^ovZ */
		dp_IFF_gateB(36, &dp.IFF_gate_b[1]);

		/* o^`rbgݒ */
		SET_PABIT(PA_K004B1);
		break;
	case 2:
		/* heeQ[g@c^ovZ */
		dp_IFF_gateC(36, &dp.IFF_gate_c[1]);

		/* o^`rbgݒ */
		SET_PABIT(PA_K004C1);
		break;
	}
}

/*=======================================================================
 |
 |		heeQ[gR
 |
 |	void	dp_IFF_gate3()
 |
 =======================================================================*/
static	void	dp_IFF_gate3(void)
{
	/* f[^`FbN */
	if (data_check(40) || data_check(41) ||
				data_check(42) || data_check(43))
		return;

	/* TCYȌꍇ\Ȃ */
	if (input_data[43] == 0)
		return;

	switch (input_data[42]) {
	case 0:
		/* heeQ[g@c^ovZ */
		dp_IFF_gateA(40, &dp.IFF_gate_a[2]);

		/* o^`rbgݒ */
		SET_PABIT(PA_K004A2);
		break;
	case 1:
		/* heeQ[g@c^ovZ */
		dp_IFF_gateB(40, &dp.IFF_gate_b[2]);

		/* o^`rbgݒ */
		SET_PABIT(PA_K004B2);
		break;
	case 2:
		/* heeQ[g@c^ovZ */
		dp_IFF_gateC(40, &dp.IFF_gate_c[2]);

		/* o^`rbgݒ */
		SET_PABIT(PA_K004C2);
		break;
	}
}

/*=======================================================================
 |
 |		heeQ[g@c^ovZ
 |
 |	void	dp_IFF_gateA()
 |
 =======================================================================*/
static	void	dp_IFF_gateA(short dno, IFF_GATE_A *dpp)
{
	short	l, l2, x, y;

	/* heeQ[g̃TCYo */
	l = DOT_TO_MM(input_data[dno + 3]);

	/* ŏTCY͂PDW */
	if (l < 180)
		l = 180;

	/* ̂P^Q߂ */
	l2 = l / 2;

	/* heeQ[g̈ʒuo */
	x = DOT_TO_MM(input_data[dno]) - 6345;
	y = 6345 - DOT_TO_MM(input_data[dno + 1]);

	/* ̈ʒûc^o̐ݒ */
	dpp->PX04A_0 = MM_TO_DP(x - l2);
	dpp->PY04A_0 = MM_TO_DP(y - l2);

	/* Ëʒûc^o̐ݒ */
	dpp->PX04A_1 = MM_TO_DP(x + l2);
	dpp->PY04A_1 = MM_TO_DP(y + l2);

	/* ̂c^o̐ݒ */
	dpp->L04A_0 = MM_TO_DP(l);
}

/*=======================================================================
 |
 |		heeQ[g@c^ovZ
 |
 |	void	dp_IFF_gateB()
 |
 =======================================================================*/
static	void	dp_IFF_gateB(short dno, IFF_GATE_B *dpp)
{
	short	l, r, x, y;

	/* heeQ[g̃TCYo */
	l = DOT_TO_MM(input_data[dno + 3]);

	/* ŏTCY͂PDW */
	if (l < 180)
		l = 180;

	/* a߂ */
	r = l / 2;

	/* heeQ[g̈ʒuo */
	x = DOT_TO_MM(input_data[dno]) - 6345;
	y = 6345 - DOT_TO_MM(input_data[dno + 1]);

	/* ~̉[̂c^o̐ݒ */
	dpp->PX04B_0 = MM_TO_DP(x);
	dpp->PY04B_0 = MM_TO_DP(y - r);

	/* ʂ̒̂c^o̐ݒ */
	dpp->L04B_0 = MM_TO_DP(ARC_LENGTH(r));

	/* âc^o̐ݒ */
	dpp->L04B_1 = radius(r);
}

/*=======================================================================
 |
 |		heeQ[g@c^ovZ
 |
 |	void	dp_IFF_gateC()
 |
 =======================================================================*/
static	void	dp_IFF_gateC(short dno, IFF_GATE_C *dpp)
{
	short	l, l2, x, y;

	/* heeQ[g̃TCYo */
	l = DOT_TO_MM(input_data[dno + 3]);

	/* ŏTCY͂PDW */
	if (l < 180)
		l = 180;

	/* ̂P^?Q߂ */
	l2 = (short)((l * 0xb504L) >> 16);

	/* heeQ[g̈ʒuo */
	x = DOT_TO_MM(input_data[dno]) - 6345;
	y = 6345 - DOT_TO_MM(input_data[dno + 1]);

	/* 㑤̈ʒûc^o̐ݒ */
	dpp->PX04C_0 = MM_TO_DP(x);
	dpp->PY04C_0 = MM_TO_DP(y + l2);

	/* ̈ʒûc^o̐ݒ */
	dpp->PX04C_1 = MM_TO_DP(x - l2);
	dpp->PY04C_1 = MM_TO_DP(y);

	/* ̈ʒûc^o̐ݒ */
	dpp->PX04C_2 = MM_TO_DP(x);
	dpp->PY04C_2 = MM_TO_DP(y - l2);

	/* Ëʒûc^o̐ݒ */
	dpp->PX04C_3 = MM_TO_DP(x + l2);
	dpp->PY04C_3 = MM_TO_DP(y);

	/* ̂c^o̐ݒ */
	dpp->L04C_0 = MM_TO_DP(l);
}

/*=======================================================================
 |
 |		R[h
 |
 |	void	dp_answer_code()
 |
 =======================================================================*/
static	void	dp_answer_code(void)
{
	static	ushort	legend[4] = {
		FONT8_A, FONT8_N, FONT8_S, FONT8_SP
	};

	/* f[^`FbN */
	if (data_check(353))
		return;

	/* R[hȌꍇ\Ȃ */
	if (input_data[353] == 0)
		return;

	/* WFhZbg */
	COPY_WORD(&dp.A143[0], legend, 4);

	/* R[hZbg */
	tohex(input_data[353], &dp.A143[4], 4, font8_tbl);

	/* c̃GAɃXy[XZbg */
	dp.A143[8] = FONT8_SP;

	/* FR[hݒ */
	dp.C142 = dp.C001;		/* ^ */

	/* o^`rbgݒ */
	SET_PABIT(PA_KD142);
}

/*=======================================================================
 |
 |		QV{
 |
 |	void	dp_obst_symbol()
 |
 =======================================================================*/
static	void	dp_obst_symbol(void)
{
	int	n;
	short	*datap, fov, fov2, s1, s2;

	/* f[^`FbN */
	if (data_check(44) || data_check(7) ||
				data_check(354) || data_check(355))
		return;

	fov = input_data[7];	/* ZTenu */

	/* ZTenuȌꍇ͕\Ȃ */
	if (fov == 0)
		return;

	/* lPCQo */
	s1 = input_data[354];
	s2 = input_data[355];
	if (s2 <= s1)
		s2 = 1000;

	fov2 = fov / 2;
	datap = &input_data[46];	/* Q̓f[^擪AhX */
	/* őPOO̏QV{` */
	for (n = 0; n < 100; n++, datap += 3) {
		/* Ȍꍇ\Ȃ */
		if (datap[2] == 0)
			continue;

		/* f[^`FbN */
		if (CHECK(datap[0], -18000, 18000) ||
				CHECK(datap[1], -8999, 8999) ||
				CHECK(datap[2], 0, 999)) {
			data_error_flag = 1;
			continue;
		}

		/* enuQ[gɂȂꍇ\Ȃ */
		if (ABS(datap[0]) > fov2 || ABS(datap[1]) > fov2)
			continue;

		/* wCxW̐ݒ */
		dp.obst[n].PX100 = DOT_TO_DP((long)dot_video * datap[0] / fov);
		dp.obst[n].PY100 = DOT_TO_DP((long)dot_video * datap[1] / fov);

		/* o^`rbgݒ */
		if (datap[2] < s1)
			SET_PABIT(PA_K0200 + n);/* lPiԁj */
		else if (datap[2] < s2)
			SET_PABIT(PA_K0100 + n);/* lQij */
		else
			SET_PABIT(PA_K0300 + n);/* lQȏi΁j */
	}
}

/*=======================================================================
 |
 |		Q܂ł̍ŒZ
 |
 |	void	dp_obst_kyori()
 |
 =======================================================================*/
static	void	dp_obst_kyori(void)
{
	short	s1, s2;

	static	ushort	legend[5] = {
		FONT8_O, FONT8_B, FONT8_S, FONT8_T, FONT8_SP
	};

	/* f[^`FbN */
	if (data_check(44) || data_check(45) ||
				data_check(354) || data_check(355))
		return;

	/* WFhZbg */
	COPY_WORD(&dp.A141[0], legend, 5);

	if (digital_update_flag) {
		/* Zbg */
		if (input_data[45] == 0) {
			SET_WORD(&dp.A141[5], FONT8_SP, 4);
			dp.C140 = COLOR_YELLOW;		/*  */
		} else {
			tonumL(input_data[45], &dp.A141[5], 3, font8_tbl,
								FONT8_SP);

			/* c̃GAɃXy[XZbg */
			dp.A141[8] = FONT8_SP;

			/* lPCQo */
			s1 = input_data[354];
			s2 = input_data[355];
			if (s2 <= s1)
				s2 = 1000;

			/* FR[hZbg */
			if (input_data[45] < s1)
				dp.C140 = COLOR_RED;		/*  */
			else if (input_data[45] < s2)
				dp.C140 = COLOR_YELLOW;		/*  */
			else
				dp.C140 = COLOR_GREEN;		/*  */
		}
	}

	/* o^`rbgݒ */
	SET_PABIT(PA_KD140);
}

/*=======================================================================
 |
 |		CӐ}`
 |
 |	void	dp_zukei()
 |
 =======================================================================*/
static	void	dp_zukei(void)
{
	int	n;
	short	dno;
	ushort	pa_bit0, pa_bit1, pa_bit2, pa_bit3;

	dno = 384;
	pa_bit0 = PA_K050A;
	pa_bit1 = PA_K051A;
	pa_bit2 = PA_K052A;
	pa_bit3 = PA_K053A;
	for (n = 0; n < 18; n++, dno += 7,
				pa_bit0++, pa_bit1++, pa_bit2++, pa_bit3++) {
		/* }`̎ނȌꍇAȍ~\Ȃ */
		if (input_data[dno] == 0)
			break;

		switch (input_data[dno]) {
		case 1:		/*  */
			dp_zukei0(dno, &dp.zukei0[n],
					&dp.zukei0[n].C05, pa_bit0);
			break;
		case 2:		/* ` */
			if (input_data[dno+6] == 0)
				/* hԂ */
				dp_zukei1(dno, &dp.zukei1[n],
						&dp.zukei0[n].C05, pa_bit1);
			else if (input_data[dno+6] == 1)
				/* hԂL */
				dp_zukei2(dno, &dp.zukei2[n],
						&dp.zukei0[n].C05, pa_bit2);
			else
				/* f[^G[ */
				data_error_flag = 1;
			break;
		case 3:		/* ~ */
			dp_zukei3(dno, &dp.zukei3[n],
					&dp.zukei0[n].C05, pa_bit3);
			break;
		default:	/* f[^G[ */
			data_error_flag = 1;
			break;
		}
	}
}

/*=======================================================================
 |
 |		CӐ}`ij
 |
 |	void	dp_zukei0()
 |
 =======================================================================*/
static	void	dp_zukei0(short dno, ZUKEI0 *dpp, ushort *color, short pa_bit)
{
	short	x1, y1, x2, y2;
	short	lx, ly;

	/* f[^`FbN */
	if (CHECK(input_data[dno+1], 0, 845) ||
			CHECK(input_data[dno+2], 0, 845) ||
			CHECK(input_data[dno+3], 0, 845) ||
			CHECK(input_data[dno+4], 0, 845) ||
			CHECK(input_data[dno+5], 1, 7)) {
		data_error_flag = 1;
		return;
	}

	/* `JnW̎o */
	x1 = DOT_TO_MM(input_data[dno+1]) - 6345;
	y1 = 6345 - DOT_TO_MM(input_data[dno+2]);

	/* `IW̎o */
	x2 = DOT_TO_MM(input_data[dno+3]) - 6345;
	y2 = 6345 - DOT_TO_MM(input_data[dno+4]);

	/* x1,y1x2,y2̑Έʒu߂ */
	lx = x2 - x1;
	ly = y2 - y1;

	/* ̕`Jnʒu(PX50x,PY50x)̐ݒ */
	dpp->PX50 = MM_TO_DP(x1);
	dpp->PY50 = MM_TO_DP(y1);

	/* ̊px(D50x)̐ݒ */
	dpp->D50 = atan(ly, lx);

	/* ̒(L50x)̐ݒ */
	dpp->L50 = MM_TO_DP(sqrt((long)lx * (long)lx + (long)ly * (long)ly));

	/* F(C05x)̐ݒ */
	*color = zukei_color_tbl[input_data[dno+5]];

	/* o^`rbgݒ */
	SET_PABIT(pa_bit);
}

/*=======================================================================
 |
 |		CӐ}`i`j
 |
 |	void	dp_zukei1()
 |
 =======================================================================*/
static	void	dp_zukei1(short dno, ZUKEI1 *dpp, ushort *color, short pa_bit)
{
	short	x1, y1, x2, y2;

	/* f[^`FbN */
	if (CHECK(input_data[dno+1], 0, 845) ||
			CHECK(input_data[dno+2], 0, 845) ||
			CHECK(input_data[dno+3], 0, 845) ||
			CHECK(input_data[dno+4], 0, 845) ||
			CHECK(input_data[dno+5], 1, 7)) {
		data_error_flag = 1;
		return;
	}

	/* `JnW̎o */
	x1 = DOT_TO_MM(input_data[dno+1]) - 6345;
	y1 = 6345 - DOT_TO_MM(input_data[dno+2]);

	/* `IW̎o */
	x2 = DOT_TO_MM(input_data[dno+3]) - 6345;
	y2 = 6345 - DOT_TO_MM(input_data[dno+4]);

	/* x1,y1Ƃ */
	if (x1 > x2)
		SWAP(x1, x2);
	if (y1 < y2)
		SWAP(y1, y2);

	/* `Jnʒu(PX51x,PY51x)̐ݒ */
	dpp->PX51 = MM_TO_DP(x1);
	dpp->PY51 = MM_TO_DP(y1);

	/* ӂ̒(LX51x,LY51x)̐ݒ */
	dpp->LX51 = MM_TO_DP(x2 - x1);
	dpp->LY51 = MM_TO_DP(y1 - y2);

	/* F(C05x)̐ݒ */
	*color = zukei_color_tbl[input_data[dno+5]];

	/* o^`rbgݒ */
	SET_PABIT(pa_bit);
}

/*=======================================================================
 |
 |		CӐ}`ihԂ`j
 |
 |	void	dp_zukei2()
 |
 =======================================================================*/
static	void	dp_zukei2(short dno, ZUKEI2 *dpp, ushort *color, short pa_bit)
{
	short	x1, y1, x2, y2;
	ushort	lx, ly;

	/* f[^`FbN */
	if (CHECK(input_data[dno+1], 0, 845) ||
			CHECK(input_data[dno+2], 0, 845) ||
			CHECK(input_data[dno+3], 0, 845) ||
			CHECK(input_data[dno+4], 0, 845) ||
			CHECK(input_data[dno+5], 1, 7)) {
		data_error_flag = 1;
		return;
	}

	/* `JnW̎o */
	x1 = DOT_TO_MM(input_data[dno+1]) - 6345;
	y1 = 6345 - DOT_TO_MM(input_data[dno+2]);

	/* `IW̎o */
	x2 = DOT_TO_MM(input_data[dno+3]) - 6345;
	y2 = 6345 - DOT_TO_MM(input_data[dno+4]);

	/* x1,y1Ƃ */
	if (x1 > x2)
		SWAP(x1, x2);
	if (y1 > y2)
		SWAP(y1, y2);

	/* ӂ̒͂P`QO܂łƂ */
	lx = x2 - x1;
	ly = y2 - y1;
	if (lx < 100 || lx > 2000 || ly < 100 || ly > 2000) {
		data_error_flag = 1;
		return;
	}

	/* SW(PX52x0,PY52x0)̐ݒ */
	dpp->PX52_0 = MM_TO_DP((x1 + x2) / 2);
	dpp->PY52_0 = MM_TO_DP((y1 + y2) / 2);

	/* FIX WINDOW̍ʒu(PX52x1,PY52x1)̐ݒ */
	dpp->PX52_1 = MM_TO_DP(x1);
	dpp->PY52_1 = MM_TO_DP(y1);

	/* FIX WINDOW̉Eʒu(PX52x2,PY52x2)̐ݒ */
	dpp->PX52_2 = MM_TO_DP(x2);
	dpp->PY52_2 = MM_TO_DP(y2);

	/* COLOR WINDOW̍ʒu(PX52x3,PY52x3)̐ݒ */
	dpp->PX52_3 = MM_TO_DP(x1-10);
	dpp->PY52_3 = MM_TO_DP(y1-10);

	/* COLOR WINDOW̉Eʒu(PX52x4,PY52x4)̐ݒ */
	dpp->PX52_4 = MM_TO_DP(x2+10);
	dpp->PY52_4 = MM_TO_DP(y2+10);

	/* F(C05x)̐ݒ */
	*color = zukei_color_tbl[input_data[dno+5]];

	/* o^`rbgݒ */
	SET_PABIT(pa_bit);
}

/*=======================================================================
 |
 |		CӐ}`i~j
 |
 |	void	dp_zukei3()
 |
 =======================================================================*/
static	void	dp_zukei3(short dno, ZUKEI3 *dpp, ushort *color, short pa_bit)
{
	short	x, y, r;

	/* f[^`FbN */
	if (CHECK(input_data[dno+1], 0, 845) ||
			CHECK(input_data[dno+2], 0, 845) ||
			CHECK(input_data[dno+3], 0, 845) ||
			CHECK(input_data[dno+4], 1, 7)) {
		data_error_flag = 1;
		return;
	}

	/* SW̎o */
	x = DOT_TO_MM(input_data[dno+1]) - 6345;
	y = 6345 - DOT_TO_MM(input_data[dno+2]);

	/* a̎o */
	r = DOT_TO_MM(input_data[dno+3]);
	if (r < 100)
		r = 90;		/* a̍ŏl͂ODXƂ */

	/* `Jnʒu(PX53,PY53)̐ݒ */
	dpp->PX53 = MM_TO_DP(x);
	dpp->PY53 = MM_TO_DP(y - r);

	/* ʂ̒(LX53x0)̐ݒ */
	dpp->L53_0 = MM_TO_DP(ARC_LENGTH(r));

	/* a(L53x1)̐ݒ */
	dpp->L53_1 = radius(r);

	/* F(C05x)̐ݒ */
	*color = zukei_color_tbl[input_data[dno+4]];

	/* o^`rbgݒ */
	SET_PABIT(pa_bit);
}

/*=======================================================================
 |
 |		ʖڐiGTCg[hQj
 |
 |	void	dp_heading_scale2()
 |
 =======================================================================*/
static	void	dp_heading_scale2(void)
{
	/* f[^`FbN */
	if (data_check(2))
		return;

	/* kwQP`ݒ */
	dp.LX21A  = MM_TO_DP((ushort)input_data[2] * 12 / 5 + 4320);

	/* o^`rbgݒ */
	SET_PABIT(PA_K021A0);
	SET_PABIT(PA_K021A1);
	SET_PABIT(PA_K021A2);
}

/*=======================================================================
 |
 |		ZTʁiGTCg[hQj
 |
 |	void	dp_sensor_heading2()
 |
 =======================================================================*/
static	void	dp_sensor_heading2(void)
{
	short	roll;
	long	heading;

	/* f[^`FbN */
	if (data_check(4) || data_check(5) || data_check(6))
		return;

	/* vZpɃ[Pʂ܂Ŏo */
	roll = ROUND(input_data[4], 10);

	/* AZ*cos(Roll) + EL*sin(Roll) vZ */
	heading = ((long)input_data[5] * (long)cos(roll) +
			(long)input_data[6] * (long)sin(roll)) >> 14;

	if (heading > 18000)
		heading -= 36000;	/* {PWOKzꍇ */
	else if (heading < -18000)
		heading += 36000;	/* |PWOKzꍇ */

	/* EH[jOQiԈ葕u䕔jP̏ꍇ͉Fŕ\ */
	if ((input_data[27] & 0x00ff) == 1) {
		/* LX21Cݒ */
		dp.LX21C = MM_TO_DP((heading + 18000) * 2160 / 9000);

		/* o^`rbgݒ */
		SET_PABIT(PA_K021C);
	} else {
		/* LX21Bݒ */
		dp.LX21B = MM_TO_DP((heading + 18000) * 2160 / 9000);

		/* o^`rbgݒ */
		SET_PABIT(PA_K021B);
	}
}

/*=======================================================================
 |
 |		sb`ڐ
 |
 |	void	dp_pitch_scale()
 |
 =======================================================================*/
static	void	dp_pitch_scale(void)
{
	/* f[^`FbN */
	if (data_check(3))
		return;

	/* kxQQ`ݒ */
	dp.LY22A  = MM_TO_DP((input_data[3] + 6000) * 1440L / 6000);

	/* o^`rbgݒ */
	SET_PABIT(PA_K022A);
}

/*=======================================================================
 |
 |		ZTsb`
 |
 |	void	dp_sensor_pitch()
 |
 =======================================================================*/
static	void	dp_sensor_pitch(void)
{
	long	az, el;
	short	roll, pitch;

	/* f[^`FbN */
	if (data_check(4) || data_check(5) || data_check(6))
		return;

	/* ZTknr̃AW}Xl␳ */
	az = input_data[5];
	if (az > 9000)
		az = 18000 - az;
	else if (az < -9000)
		az = -18000 - az;

	/* ZTknr̃Gx[Vlo */
	el = input_data[6];

	/* vZpɃ[Pʂ܂Ŏo */
	roll = ROUND(input_data[4], 10);

	/* AZ*sin(Roll) + EL*cos(Roll) vZ */
	pitch = (short)((az * sin(roll) + el * cos(roll)) >> 14);

	/* ͈͕␳ */
	if (pitch > 6000)
		pitch = 6000;
	else if (pitch < -6000)
		pitch = -6000;

	/* EH[jOQiԈ葕u䕔jP̏ꍇ͉Fŕ\ */
	if ((input_data[27] & 0x00ff) == 1) {
		/* LY22Cݒ */
		dp.LY22C = MM_TO_DP((pitch + 6000) * 1440L / 6000);

		/* o^`rbgݒ */
		SET_PABIT(PA_K022C);
	} else {
		/* LY22Bݒ */
		dp.LY22B = MM_TO_DP((pitch + 6000) * 1440L / 6000);

		/* o^`rbgݒ */
		SET_PABIT(PA_K022B);
	}
}

/*=======================================================================
 |
 |		~TCsb`
 |
 |	void	dp_missile_pitch()
 |
 =======================================================================*/
static	void	dp_missile_pitch(void)
{
	long	mwaz, mwel;
	short	roll, pitch;

	/* f[^`FbN */
	if (data_check(4) || data_check(5) || data_check(6))
		return;

	/* lvAŽvZ */
	mwaz = (long)input_data[30] + (long)input_data[5];
	if (mwaz > 9000)
		mwaz = 18000 - mwaz;
	else if (mwaz < -9000)
		mwaz = -18000 - mwaz;

	/* lvEĽvZ */
	mwel = (long)input_data[31] + (long)input_data[6];
	if (mwel > 9000)
		mwel = 18000 - mwel;
	else if (mwel < -9000)
		mwel = -18000 - mwel;

	/* vZpɃ[Pʂ܂Ŏo */
	roll = ROUND(input_data[4], 10);

	/* lvAZ*sin(Roll) + lvEL*cos(Roll) + Pitch vZ */
	pitch = (short)((mwaz * sin(roll) + mwel * cos(roll)) >> 14);

	/* ͈͕␳ */
	if (pitch > 6000)
		pitch = 6000;
	else if (pitch < -6000)
		pitch = -6000;

	/* LY26ݒ */
	dp.LY26 = MM_TO_DP((pitch + 6000) * 1440L / 6000);

	/* o^`rbgݒ */
	SET_PABIT(PA_K026);
}

/*=======================================================================
 |
 |		@ʁifW^j
 |
 |	void	dp_heading_digital()
 |
 =======================================================================*/
static	void	dp_heading_digital(void)
{
	short	tmp;

	/* f[^`FbN */
	if (data_check(2))
		return;

	if (digital_update_flag) {
		/* lZbg */
		tmp = ROUND(input_data[2], 10);		/* ȉľܓ */
		tonumR(tmp, &dp.A171[0], 3, font8_tbl, FONT8_0);
	}

	/* o^`rbgݒ */
	SET_PABIT(PA_KD17);
}

/*=======================================================================
 |
 |		XV[g
 |
 |	void	dp_update_rate()
 |
 =======================================================================*/
static	void	dp_update_rate(void)
{
	if (rate_dsp_flag == 0)
		return;

	/* \̍XV[gZbg */
	tonumR(rate_gscint, &dp.A191[0], 2, font8_tbl, FONT8_0);

	/* PTTRaoX̍XV[gZbg */
	tonumR(rate_1553B, &dp.A191[2], 2, font8_tbl, FONT8_0);

	/* o^`rbgݒ */
	SET_PABIT(PA_KD19);
}

/*=======================================================================
 |
 |		~TCx
 |
 |	void	dp_missile()
 |
 =======================================================================*/
static	void	dp_missile(void)
{
	long	mwaz, mwel;

	/* lvAŽvZ */
	if (data_check(5) || data_check(30))
		mwaz = -18001;		/* f[^G[ */
	else {
		mwaz = (long)input_data[30] + (long)input_data[5];
		if (mwaz > 18000)
			mwaz -= 36000;
		else if (mwaz < -18000)
			mwaz += 36000;
	}

	/* lvEĽvZ */
	if (data_check(6) || data_check(31))
		mwel = -9001;		/* f[^G[ */
	else {
		mwel = (long)input_data[31] + (long)input_data[6];
		if (mwel > 9000)
			mwel = 18000 - mwel;
		else if (mwel < -9000)
			mwel = -18000 - mwel;
	}

	dp_missile_s1((short)mwaz, (short)mwel);
	dp_missile_s2((short)mwaz, (short)mwel);
	dp_missile_digital((short)mwaz, (short)mwel);
}

/*=======================================================================
 |
 |		@̌̃V{
 |
 |	void	dp_missile_s1()
 |
 =======================================================================*/
static	void	dp_missile_s1(short mwaz, short mwel)
{
	short	tmp_mwaz, tmp_mwel, x, y, L2;
	long	L1_2;
	ushort	theta, alpha;

	if (mwaz == -18001 || mwel == -9001) {
		/* f[^G[̏ꍇ͊O~Ƌ@̃VGbĝݕ\ */
		SET_PABIT(PA_K044A);	/* O~ƕ */
		SET_PABIT(PA_K042A);	/* @̃VGbg */
		return;
	}

	tmp_mwaz = ROUND(mwaz, 10);
	tmp_mwel = ROUND(mwel, 10);
	x = (short)((((2790L * sin(tmp_mwaz)) >> 14) * cos(tmp_mwel)) >> 14);
	y = (short)((2790L * sin(tmp_mwel)) >> 14);

	/* L1*L1 ̌vZ */
	L1_2 = (long)x * (long)x + (long)y * (long)y;

	/* L2 ̌vZ */
	if (L1_2 > 41006L)
		L2 = sqrt(L1_2 - 41006L);
	else
		L2 = 0;

	/* L40A ̐ݒ */
	dp.L40A = MM_TO_DP(L2);

	/* Ƃ̌vZ */
	theta = atan(y, x);

	/* ^Q̌vZ */
	alpha = atan(405 / 2, L2);

	/* D40A0`D40A4 ̐ݒ */
	dp.D40A0 = theta + alpha;
	dp.D40A1 = theta + alpha / 2;
	dp.D40A2 = theta;
	dp.D40A3 = theta - alpha / 2;
	dp.D40A4 = theta - alpha;

	/* PX40B̐ݒ */
	dp.PX40B = MM_TO_DP(x);

	/* PY40B̐ݒ */
	dp.PY40B = MM_TO_DP(y + 2955);

	/* o^`rbgݒ */
	if (mwaz <= 9000 && mwaz >= -9000) {
		/* }XOK͈͓ */
		SET_PABIT(PA_K044A);	/* O~ƕ */
		SET_PABIT(PA_K042A);	/* @̃VGbg */
		SET_PABIT(PA_K040A);	/* ~TC̉~ */
		SET_PABIT(PA_K040B);	/* T{̐ */
	} else {
		/* }XOK͈͊O */
		SET_PABIT(PA_K048A);	/* O~ƕ */
		SET_PABIT(PA_K047A);	/* @̃VGbg */
		SET_PABIT(PA_K045A);	/* ~TC̉~ */
		SET_PABIT(PA_K045B);	/* T{̐ */
	}
}

/*=======================================================================
 |
 |		@̏̃V{
 |
 |	void	dp_missile_s2()
 |
 =======================================================================*/
static	void	dp_missile_s2(short mwaz, short mwel)
{
	short	tmp_mwaz, tmp_mwel, x, y, L2;
	long	L1_2;
	ushort	theta, alpha;

	if (mwaz == -18001 || mwel == -9001) {
		/* f[^G[̏ꍇ͊O~Ƌ@̃VGbĝݕ\ */
		SET_PABIT(PA_K044B);	/* O~ƕ */
		SET_PABIT(PA_K042B);	/* @̃VGbg */
		return;
	}

	tmp_mwaz = ROUND(mwaz, 10);
	tmp_mwel = ROUND(mwel, 10);
	x = (short)((((2790L * sin(tmp_mwaz)) >> 14) * cos(tmp_mwel)) >> 14);
	y = (short)((((2790L * cos(tmp_mwel)) >> 14) * cos(tmp_mwaz)) >> 14);

	/* L1*L1 ̌vZ */
	L1_2 = (long)x * (long)x + (long)y * (long)y;

	/* L2 ̌vZ */
	if (L1_2 > 41006L)
		L2 = sqrt(L1_2 - 41006L);
	else
		L2 = 0;

	/* L41A ̐ݒ */
	dp.L41A = MM_TO_DP(L2);

	/* Ƃ̌vZ */
	theta = atan(y, x);

	/* ^Q̌vZ */
	alpha = atan(405 / 2, L2);

	/* D41A0`D41A4 ̐ݒ */
	dp.D41A0 = theta + alpha;
	dp.D41A1 = theta + alpha / 2;
	dp.D41A2 = theta;
	dp.D41A3 = theta - alpha / 2;
	dp.D41A4 = theta - alpha;

	/* PX41B̐ݒ */
	dp.PX41B = MM_TO_DP(x);

	/* PY41B̐ݒ */
	dp.PY41B = MM_TO_DP(y - 2955);

	/* o^`rbgݒ */
	if (mwel >= 0) {
		/* OKȏ */
		SET_PABIT(PA_K044B);	/* O~ƕ */
		SET_PABIT(PA_K042B);	/* @̃VGbg */
		SET_PABIT(PA_K041A);	/* ~TC̉~ */
		SET_PABIT(PA_K041B);	/* T{̐ */
	} else {
		/* OK */
		SET_PABIT(PA_K048B);	/* O~ƕ */
		SET_PABIT(PA_K047B);	/* @̃VGbg */
		SET_PABIT(PA_K046A);	/* ~TC̉~ */
		SET_PABIT(PA_K046B);	/* T{̐ */
	}
}

/*=======================================================================
 |
 |		fW^lWFh
 |
 |	void	dp_missile_digital()
 |
 =======================================================================*/
static	void	dp_missile_digital(short mwaz, short mwel)
{
	static	ushort	legend_lost[7] = {
		FONT8_L, FONT8_O, FONT8_S, FONT8_T,
		FONT8_SP, FONT8_SP, FONT8_SP
	};
	short	tmp;

	/* WFh(A4310`A4316)ݒ */
	if ((input_data[29] & 0x00ff) == 1) {
		COPY_WORD(&dp.A431[0], legend_lost, 7);
	} else {
		SET_WORD(&dp.A431[0], FONT8_SP, 7);
	}

	/* Gx[Vl(A4320`A4325)ݒ */
	dp.A432[0] = FONT8_E;
	dp.A432[1] = FONT8_L;
	if (mwel != -9001) {
		if (digital_update_flag) {
			tmp = ROUND(mwel, 100);	/* Gx[Vl */
			if (tmp > 0)
				dp.A432[2] = FONT8_PLUS;
			else if (tmp < 0) {
				dp.A432[2] = FONT8_MINUS;
				tmp = -tmp;
			} else
				dp.A432[2] = FONT8_SP;
			tonumR(tmp, &dp.A432[3], 3, font8_tbl, FONT8_SP);
		}
	} else {
		SET_WORD(&dp.A432[3], FONT8_SP, 3);
	}

	/* AW}Xl(A4330`A4335)ݒ */
	dp.A433[0] = FONT8_A;
	dp.A433[1] = FONT8_Z;
	if (mwaz != -18001) {
		if (digital_update_flag) {
			tmp = ROUND(mwaz, 100);	/* AW}Xl */
			if (tmp > 0)
				dp.A433[2] = FONT8_R;
			else if (tmp < 0) {
				dp.A433[2] = FONT8_L;
				tmp = -tmp;
			} else
				dp.A433[2] = FONT8_SP;
			tonumR(tmp, &dp.A433[3], 3, font8_tbl, FONT8_SP);
		}
	} else {
		SET_WORD(&dp.A433[3], FONT8_SP, 3);
	}

	/* o^`rbgݒ */
	SET_PABIT(PA_KD43);
}
